REM Find the BES Client directory
FOR /F "tokens=2*" %%a IN ('reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\BESClient.exe" /v Path') DO SET BESDIR=%%~pb%%~nb
FOR /F "tokens=2*" %%a IN ('reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\App Paths\BESClient.exe" /v Path') DO SET BESDIR=%%~pb%%~nb

REM Make sure the BES Client is not installed
if not "%BESDIR%"=="" goto end

set BFOSDDIR=%SystemDrive%\Deploy\$OEM$\BigFixOSD

REM Install the BES Client
start "Install BES Client" /wait "%BFOSDDIR%\ClientInstall\9.0\setup.exe" /s /v"STARTAGENTSERVICE=0 /qn"

REM Make sure the BES Client was saved from the old OS
if not exist "%BFOSDDIR%\BES Client" goto end

REM Find the BES Client directory
FOR /F "tokens=2*" %%a IN ('reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\BESClient.exe" /v Path') DO SET BESDIR=%%~pb%%~nb
FOR /F "tokens=2*" %%a IN ('reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\App Paths\BESClient.exe" /v Path') DO SET BESDIR=%%~pb%%~nb

set BESDIR=%SystemDrive%%BESDIR%
if "%BESDIR:~-1%"=="\" SET BESDIR=%BESDIR:~0,-1%

rmdir /S /Q "%BESDIR%"

%SystemDrive%\Deploy\Tools\x86\dirmove.exe "%BFOSDDIR%\BES Client" "%BESDIR%"

reg query "HKLM\Hardware\Description\System\CentralProcessor\0" /v Identifier | find "x86"
If %ERRORLEVEL% == 0 (
    REM x86 case
    SET PARENTKEY=HKEY_LOCAL_MACHINE\SOFTWARE\BigFix\EnterpriseClient
) ELSE (
    REM x64 case
    SET PARENTKEY=HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\BigFix\EnterpriseClient
)

REM collect registry keys to migrate
reg query "%PARENTKEY%" /v EnterpriseClientFolder
if %ERRORLEVEL% == 0  FOR /F "tokens=2*" %%a IN ('reg query "%PARENTKEY%" /v EnterpriseClientFolder') DO SET ClientFolder=%%~db%%~pb%%~nb
reg query "%PARENTKEY%\GlobalOptions" /v StoragePath
if %ERRORLEVEL% == 0  FOR /F "tokens=2*" %%a IN ('reg query "%PARENTKEY%\GlobalOptions" /v StoragePath') DO SET StoragePath=%%~db%%~pb%%~nb
reg query "%PARENTKEY%\GlobalOptions" /v LibPath
if %ERRORLEVEL% == 0  FOR /F "tokens=2*" %%a IN ('reg query "%PARENTKEY%\GlobalOptions" /v LibPath') DO SET LibPath=%%~db%%~pb%%~nb
reg query "%PARENTKEY%\Settings\Client\_BESClient_UploadManager_BufferDirectory" /v value
if %ERRORLEVEL% == 0  FOR /F "tokens=2*" %%a IN ('reg query "%PARENTKEY%\Settings\Client\_BESClient_UploadManager_BufferDirectory" /v value') DO SET BufferDirectory=%%~db%%~pb%%~nb

REM Update the BES Client Settings
reg import "%BFOSDDIR%\RegistryKeys\_removeSettings.reg"
reg import "%BFOSDDIR%\RegistryKeys\_storedSettings.reg"
reg import "%BFOSDDIR%\RegistryKeys\_tag_image.reg"

REM restore registry keys
SET lastChar=%ClientFolder:~-1%
if %lastChar%==\ SET ClientFolderNew=%ClientFolder:~0,-1%
if %lastChar%==\ SET ClientFolder=%ClientFolder%\

SET lastChar=%StoragePath:~-1%
if %lastChar%==\ SET StoragePath=%StoragePath%\

SET lastChar=%LibPath:~-1%
if %lastChar%==\ SET LibPath=%LibPath%\

SET lastChar=%BufferDirectory:~-1%
if %lastChar%==\ SET BufferDirectory=%BufferDirectory%\

if not "%ClientFolder%"=="" (reg add "%PARENTKEY%" /v EnterpriseClientFolder /f /d "%ClientFolder%")

if not "%StoragePath%"=="" (
reg add "%PARENTKEY%\GlobalOptions" /v StoragePath /f /d "%StoragePath%"
) ELSE (
REM WARNING StoragePath could not be found
if not "%ClientFolder%"=="" (reg add "%PARENTKEY%\GlobalOptions" /v StoragePath /f /d "%ClientFolder%")
)

if not "%LibPath%"=="" (reg add "%PARENTKEY%\GlobalOptions" /v LibPath /f /d "%LibPath%")

if not "%BufferDirectory%"=="" (
reg add "%PARENTKEY%\Settings\Client\_BESClient_UploadManager_BufferDirectory" /v value /f /d "%BufferDirectory%"
) ELSE ( 
reg add "%PARENTKEY%\Settings\Client\_BESClient_UploadManager_BufferDirectory" /v value /f /d "%ClientFolderNew%\__BESData\__Global\Upload"
)
REM Start the BES Client
net start BESClient

:end